Index: /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DYN/dynnxt.F90
===================================================================
--- /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DYN/dynnxt.F90	(revision 10115)
+++ /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DYN/dynnxt.F90	(revision 10116)
@@ -95,7 +95,8 @@
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      INTEGER  ::   ikt          ! local integers
+      INTEGER  ::   ikt, jkbot   ! local integers
       REAL(wp) ::   zue3a, zue3n, zue3b, zuf, zcoef    ! local scalars
       REAL(wp) ::   zve3a, zve3n, zve3b, zvf, z1_2dt   !   -      -
+      REAL(wp) ::   zhcri, zmsku, zwgtu, zmskv, zwgtv  !   -      -
       REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   zue, zve
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ze3u_f, ze3v_f, zua, zva 
@@ -136,4 +137,32 @@
             END DO  
          ENDIF
+      ENDIF
+
+      IF( ln_vvl_ztilde .OR. ln_vvl_layer) THEN 
+!         ! Duplicate baroclinic velocities from above in massless layers
+!         ! Correction to handle correct barotropic velocities right after
+         zhcri = 0.1_wp
+         DO ji = 2, jpim1
+            DO jj= 2, jpjm1
+               jkbot=jpkm1
+               DO jk=jpkm1,2,-1
+                  IF (e3u_a(ji,jj,jk)>zhcri) jkbot = jk+1
+               END DO
+               DO jk=jkbot,jpkm1
+                  zwgtu = MIN(zhcri, e3u_a(ji,jj,jk))
+                  zmsku = 0.5_wp * ( 1._wp + SIGN(1._wp, e3u_a(ji,jj,jk) - 0.01_wp) )
+                  ua(ji,jj,jk) = zmsku * (zwgtu * ua(ji,jj,jk) + (zhcri - zwgtu) * ua(ji,jj,jk-1)*zwgtu/(zwgtu+0.01_wp)) / zhcri
+               END DO
+               jkbot=jpkm1
+               DO jk=jpkm1,2,-1
+                  IF (e3v_a(ji,jj,jk)>zhcri) jkbot = jk+1
+               END DO
+               DO jk=jkbot,jpkm1
+                  zwgtv = MIN(zhcri, e3v_a(ji,jj,jk))
+                  zmskv = 0.5_wp * ( 1._wp + SIGN(1._wp, e3v_a(ji,jj,jk) - 0.01_wp) )
+                  va(ji,jj,jk) = zmskv * (zwgtv * va(ji,jj,jk) + (zhcri - zwgtv) * va(ji,jj,jk-1)*zwgtv/(zwgtv+0.01_wp)) / zhcri
+               END DO
+            END DO
+         END DO
       ENDIF
 
@@ -291,7 +320,9 @@
                         zuf = ( zue3n + atfp * ( zue3b - 2._wp * zue3n  + zue3a ) ) / ze3u_f(ji,jj,jk)
                         zvf = ( zve3n + atfp * ( zve3b - 2._wp * zve3n  + zve3a ) ) / ze3v_f(ji,jj,jk)
+                        zmsku = 0.5_wp * ( 1._wp + SIGN(1._wp, ze3u_f(ji,jj,jk) - 0.01_wp) )
+                        zmskv = 0.5_wp * ( 1._wp + SIGN(1._wp, ze3v_f(ji,jj,jk) - 0.01_wp) )
                         !
-                        ub(ji,jj,jk) = zuf                     ! ub <-- filtered velocity
-                        vb(ji,jj,jk) = zvf
+                        ub(ji,jj,jk) = zmsku * zuf             ! ub <-- filtered velocity
+                        vb(ji,jj,jk) = zmskv * zvf
                         un(ji,jj,jk) = ua(ji,jj,jk)            ! un <-- ua
                         vn(ji,jj,jk) = va(ji,jj,jk)
Index: /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/SBC/sbcwave.F90
===================================================================
--- /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/SBC/sbcwave.F90	(revision 10115)
+++ /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/SBC/sbcwave.F90	(revision 10116)
@@ -21,5 +21,4 @@
    USE zdf_oce,  ONLY : ln_zdfswm
    USE bdy_oce        ! open boundary condition variables
-   USE domvvl         ! domain: variable volume layers
    !
    USE iom            ! I/O manager library
